# coding: utf-8

"""
    Canva Connect API

    API for building integrations with Canva via a REST api

    The version of the OpenAPI document: latest
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from canva_alpha_ti.models.chart_data_field import ChartDataField
from canva_alpha_ti.models.image_data_field import ImageDataField
from canva_alpha_ti.models.text_data_field import TextDataField
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

DATAFIELD_ONE_OF_SCHEMAS = ["ChartDataField", "ImageDataField", "TextDataField"]

class DataField(BaseModel):
    """
    A named data field that can be autofilled in the brand template.
    """
    # data type: ImageDataField
    oneof_schema_1_validator: Optional[ImageDataField] = None
    # data type: TextDataField
    oneof_schema_2_validator: Optional[TextDataField] = None
    # data type: ChartDataField
    oneof_schema_3_validator: Optional[ChartDataField] = None
    actual_instance: Optional[Union[ChartDataField, ImageDataField, TextDataField]] = None
    one_of_schemas: Set[str] = { "ChartDataField", "ImageDataField", "TextDataField" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = DataField.model_construct()
        error_messages = []
        match = 0
        # validate data type: ImageDataField
        if not isinstance(v, ImageDataField):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ImageDataField`")
        else:
            match += 1
        # validate data type: TextDataField
        if not isinstance(v, TextDataField):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TextDataField`")
        else:
            match += 1
        # validate data type: ChartDataField
        if not isinstance(v, ChartDataField):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ChartDataField`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in DataField with oneOf schemas: ChartDataField, ImageDataField, TextDataField. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in DataField with oneOf schemas: ChartDataField, ImageDataField, TextDataField. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into ImageDataField
        try:
            instance.actual_instance = ImageDataField.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into TextDataField
        try:
            instance.actual_instance = TextDataField.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ChartDataField
        try:
            instance.actual_instance = ChartDataField.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into DataField with oneOf schemas: ChartDataField, ImageDataField, TextDataField. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into DataField with oneOf schemas: ChartDataField, ImageDataField, TextDataField. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], ChartDataField, ImageDataField, TextDataField]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


