# coding: utf-8

"""
    Canva Connect API

    API for building integrations with Canva via a REST api

    The version of the OpenAPI document: latest
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from canva_alpha_ti.models.boolean_data_table_cell import BooleanDataTableCell
from canva_alpha_ti.models.date_data_table_cell import DateDataTableCell
from canva_alpha_ti.models.number_data_table_cell import NumberDataTableCell
from canva_alpha_ti.models.string_data_table_cell import StringDataTableCell
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

DATATABLECELL_ONE_OF_SCHEMAS = ["BooleanDataTableCell", "DateDataTableCell", "NumberDataTableCell", "StringDataTableCell"]

class DataTableCell(BaseModel):
    """
    A single tabular data cell.
    """
    # data type: StringDataTableCell
    oneof_schema_1_validator: Optional[StringDataTableCell] = None
    # data type: NumberDataTableCell
    oneof_schema_2_validator: Optional[NumberDataTableCell] = None
    # data type: BooleanDataTableCell
    oneof_schema_3_validator: Optional[BooleanDataTableCell] = None
    # data type: DateDataTableCell
    oneof_schema_4_validator: Optional[DateDataTableCell] = None
    actual_instance: Optional[Union[BooleanDataTableCell, DateDataTableCell, NumberDataTableCell, StringDataTableCell]] = None
    one_of_schemas: Set[str] = { "BooleanDataTableCell", "DateDataTableCell", "NumberDataTableCell", "StringDataTableCell" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = DataTableCell.model_construct()
        error_messages = []
        match = 0
        # validate data type: StringDataTableCell
        if not isinstance(v, StringDataTableCell):
            error_messages.append(f"Error! Input type `{type(v)}` is not `StringDataTableCell`")
        else:
            match += 1
        # validate data type: NumberDataTableCell
        if not isinstance(v, NumberDataTableCell):
            error_messages.append(f"Error! Input type `{type(v)}` is not `NumberDataTableCell`")
        else:
            match += 1
        # validate data type: BooleanDataTableCell
        if not isinstance(v, BooleanDataTableCell):
            error_messages.append(f"Error! Input type `{type(v)}` is not `BooleanDataTableCell`")
        else:
            match += 1
        # validate data type: DateDataTableCell
        if not isinstance(v, DateDataTableCell):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DateDataTableCell`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in DataTableCell with oneOf schemas: BooleanDataTableCell, DateDataTableCell, NumberDataTableCell, StringDataTableCell. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in DataTableCell with oneOf schemas: BooleanDataTableCell, DateDataTableCell, NumberDataTableCell, StringDataTableCell. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into StringDataTableCell
        try:
            instance.actual_instance = StringDataTableCell.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into NumberDataTableCell
        try:
            instance.actual_instance = NumberDataTableCell.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into BooleanDataTableCell
        try:
            instance.actual_instance = BooleanDataTableCell.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into DateDataTableCell
        try:
            instance.actual_instance = DateDataTableCell.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into DataTableCell with oneOf schemas: BooleanDataTableCell, DateDataTableCell, NumberDataTableCell, StringDataTableCell. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into DataTableCell with oneOf schemas: BooleanDataTableCell, DateDataTableCell, NumberDataTableCell, StringDataTableCell. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], BooleanDataTableCell, DateDataTableCell, NumberDataTableCell, StringDataTableCell]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


