# coding: utf-8

"""
    Canva Connect API

    API for building integrations with Canva via a REST api

    The version of the OpenAPI document: latest
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from canva_alpha_ti.models.dataset_chart_value import DatasetChartValue
from canva_alpha_ti.models.dataset_image_value import DatasetImageValue
from canva_alpha_ti.models.dataset_text_value import DatasetTextValue
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

DATASETVALUE_ONE_OF_SCHEMAS = ["DatasetChartValue", "DatasetImageValue", "DatasetTextValue"]

class DatasetValue(BaseModel):
    """
    The data field to autofill.
    """
    # data type: DatasetImageValue
    oneof_schema_1_validator: Optional[DatasetImageValue] = None
    # data type: DatasetTextValue
    oneof_schema_2_validator: Optional[DatasetTextValue] = None
    # data type: DatasetChartValue
    oneof_schema_3_validator: Optional[DatasetChartValue] = None
    actual_instance: Optional[Union[DatasetChartValue, DatasetImageValue, DatasetTextValue]] = None
    one_of_schemas: Set[str] = { "DatasetChartValue", "DatasetImageValue", "DatasetTextValue" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = DatasetValue.model_construct()
        error_messages = []
        match = 0
        # validate data type: DatasetImageValue
        if not isinstance(v, DatasetImageValue):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DatasetImageValue`")
        else:
            match += 1
        # validate data type: DatasetTextValue
        if not isinstance(v, DatasetTextValue):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DatasetTextValue`")
        else:
            match += 1
        # validate data type: DatasetChartValue
        if not isinstance(v, DatasetChartValue):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DatasetChartValue`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in DatasetValue with oneOf schemas: DatasetChartValue, DatasetImageValue, DatasetTextValue. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in DatasetValue with oneOf schemas: DatasetChartValue, DatasetImageValue, DatasetTextValue. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into DatasetImageValue
        try:
            instance.actual_instance = DatasetImageValue.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into DatasetTextValue
        try:
            instance.actual_instance = DatasetTextValue.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into DatasetChartValue
        try:
            instance.actual_instance = DatasetChartValue.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into DatasetValue with oneOf schemas: DatasetChartValue, DatasetImageValue, DatasetTextValue. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into DatasetValue with oneOf schemas: DatasetChartValue, DatasetImageValue, DatasetTextValue. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], DatasetChartValue, DatasetImageValue, DatasetTextValue]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


