# coding: utf-8

"""
    Canva Connect API

    API for building integrations with Canva via a REST api

    The version of the OpenAPI document: latest
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class DesignImportMetadata(BaseModel):
    """
    Metadata about the design that you include as a header parameter when importing a design.
    """ # noqa: E501
    title_base64: Annotated[str, Field(min_length=1, strict=True)] = Field(description="The design's title, encoded in Base64.  The maximum length of a design title in Canva (unencoded) is 50 characters.  Base64 encoding allows titles containing emojis and other special characters to be sent using HTTP headers. For example, \"My Awesome Design 😍\" Base64 encoded is `TXkgQXdlc29tZSBEZXNpZ24g8J+YjQ==`.")
    mime_type: Optional[StrictStr] = Field(default=None, description="The MIME type of the file being imported. If not provided, Canva attempts to automatically detect the type of the file.")
    __properties: ClassVar[List[str]] = ["title_base64", "mime_type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DesignImportMetadata from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DesignImportMetadata from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "title_base64": obj.get("title_base64"),
            "mime_type": obj.get("mime_type")
        })
        return _obj


