# coding: utf-8

"""
    Canva Connect API

    API for building integrations with Canva via a REST api

    The version of the OpenAPI document: latest
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from canva_alpha_ti.models.design_item import DesignItem
from canva_alpha_ti.models.folder_item import FolderItem
from canva_alpha_ti.models.image_item import ImageItem
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

FOLDERITEMSUMMARY_ONE_OF_SCHEMAS = ["DesignItem", "FolderItem", "ImageItem"]

class FolderItemSummary(BaseModel):
    """
    Details about the folder item.
    """
    # data type: FolderItem
    oneof_schema_1_validator: Optional[FolderItem] = None
    # data type: DesignItem
    oneof_schema_2_validator: Optional[DesignItem] = None
    # data type: ImageItem
    oneof_schema_3_validator: Optional[ImageItem] = None
    actual_instance: Optional[Union[DesignItem, FolderItem, ImageItem]] = None
    one_of_schemas: Set[str] = { "DesignItem", "FolderItem", "ImageItem" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = FolderItemSummary.model_construct()
        error_messages = []
        match = 0
        # validate data type: FolderItem
        if not isinstance(v, FolderItem):
            error_messages.append(f"Error! Input type `{type(v)}` is not `FolderItem`")
        else:
            match += 1
        # validate data type: DesignItem
        if not isinstance(v, DesignItem):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DesignItem`")
        else:
            match += 1
        # validate data type: ImageItem
        if not isinstance(v, ImageItem):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ImageItem`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in FolderItemSummary with oneOf schemas: DesignItem, FolderItem, ImageItem. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in FolderItemSummary with oneOf schemas: DesignItem, FolderItem, ImageItem. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into FolderItem
        try:
            instance.actual_instance = FolderItem.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into DesignItem
        try:
            instance.actual_instance = DesignItem.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ImageItem
        try:
            instance.actual_instance = ImageItem.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into FolderItemSummary with oneOf schemas: DesignItem, FolderItem, ImageItem. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into FolderItemSummary with oneOf schemas: DesignItem, FolderItem, ImageItem. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], DesignItem, FolderItem, ImageItem]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


