# coding: utf-8

"""
    Canva Connect API

    API for building integrations with Canva via a REST api

    The version of the OpenAPI document: latest
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class IntrospectTokenResponse(BaseModel):
    """
    Introspection result of access or refresh tokens
    """ # noqa: E501
    active: StrictBool = Field(description="Whether the access token is active.  If `true`, the access token is valid and active. If `false`, the access token is invalid. ")
    scope: Optional[StrictStr] = Field(default=None, description="The [scopes](https://www.canva.dev/docs/connect/appendix/scopes/) that the token has been granted.")
    client: Optional[StrictStr] = Field(default=None, description="The ID of the client that requested the token.")
    exp: Optional[StrictInt] = Field(default=None, description="The expiration time of the token, as a [Unix timestamp](https://en.wikipedia.org/wiki/Unix_time) in seconds.")
    iat: Optional[StrictInt] = Field(default=None, description="When the token was issued, as a [Unix timestamp](https://en.wikipedia.org/wiki/Unix_time) in seconds.")
    nbf: Optional[StrictInt] = Field(default=None, description="The \"not before\" time of the token, which specifies the time before which the access token most not be accepted, as a [Unix timestamp](https://en.wikipedia.org/wiki/Unix_time) in seconds.")
    jti: Optional[StrictStr] = Field(default=None, description="A unique ID for the access token.")
    sub: Optional[StrictStr] = Field(default=None, description="The subject of the claim. This is the ID of the Canva user that the access token acts on behalf of.  This is an obfuscated value, so a single user has a unique ID for each integration. If the same user authorizes another integration, their ID in that other integration is different. ")
    __properties: ClassVar[List[str]] = ["active", "scope", "client", "exp", "iat", "nbf", "jti", "sub"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of IntrospectTokenResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of IntrospectTokenResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "active": obj.get("active"),
            "scope": obj.get("scope"),
            "client": obj.get("client"),
            "exp": obj.get("exp"),
            "iat": obj.get("iat"),
            "nbf": obj.get("nbf"),
            "jti": obj.get("jti"),
            "sub": obj.get("sub")
        })
        return _obj


