# coding: utf-8

"""
    Canva Connect API

    API for building integrations with Canva via a REST api

    The version of the OpenAPI document: latest
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from canva_alpha_ti.models.add_suggestion_content import AddSuggestionContent
from canva_alpha_ti.models.delete_suggestion_content import DeleteSuggestionContent
from canva_alpha_ti.models.format_suggestion_content import FormatSuggestionContent
from canva_alpha_ti.models.replace_suggestion_content import ReplaceSuggestionContent
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

SUGGESTIONCONTENT_ONE_OF_SCHEMAS = ["AddSuggestionContent", "DeleteSuggestionContent", "FormatSuggestionContent", "ReplaceSuggestionContent"]

class SuggestionContent(BaseModel):
    """
    The suggestion's content.
    """
    # data type: AddSuggestionContent
    oneof_schema_1_validator: Optional[AddSuggestionContent] = None
    # data type: DeleteSuggestionContent
    oneof_schema_2_validator: Optional[DeleteSuggestionContent] = None
    # data type: ReplaceSuggestionContent
    oneof_schema_3_validator: Optional[ReplaceSuggestionContent] = None
    # data type: FormatSuggestionContent
    oneof_schema_4_validator: Optional[FormatSuggestionContent] = None
    actual_instance: Optional[Union[AddSuggestionContent, DeleteSuggestionContent, FormatSuggestionContent, ReplaceSuggestionContent]] = None
    one_of_schemas: Set[str] = { "AddSuggestionContent", "DeleteSuggestionContent", "FormatSuggestionContent", "ReplaceSuggestionContent" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = SuggestionContent.model_construct()
        error_messages = []
        match = 0
        # validate data type: AddSuggestionContent
        if not isinstance(v, AddSuggestionContent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AddSuggestionContent`")
        else:
            match += 1
        # validate data type: DeleteSuggestionContent
        if not isinstance(v, DeleteSuggestionContent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DeleteSuggestionContent`")
        else:
            match += 1
        # validate data type: ReplaceSuggestionContent
        if not isinstance(v, ReplaceSuggestionContent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ReplaceSuggestionContent`")
        else:
            match += 1
        # validate data type: FormatSuggestionContent
        if not isinstance(v, FormatSuggestionContent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `FormatSuggestionContent`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in SuggestionContent with oneOf schemas: AddSuggestionContent, DeleteSuggestionContent, FormatSuggestionContent, ReplaceSuggestionContent. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in SuggestionContent with oneOf schemas: AddSuggestionContent, DeleteSuggestionContent, FormatSuggestionContent, ReplaceSuggestionContent. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into AddSuggestionContent
        try:
            instance.actual_instance = AddSuggestionContent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into DeleteSuggestionContent
        try:
            instance.actual_instance = DeleteSuggestionContent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ReplaceSuggestionContent
        try:
            instance.actual_instance = ReplaceSuggestionContent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into FormatSuggestionContent
        try:
            instance.actual_instance = FormatSuggestionContent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into SuggestionContent with oneOf schemas: AddSuggestionContent, DeleteSuggestionContent, FormatSuggestionContent, ReplaceSuggestionContent. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into SuggestionContent with oneOf schemas: AddSuggestionContent, DeleteSuggestionContent, FormatSuggestionContent, ReplaceSuggestionContent. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], AddSuggestionContent, DeleteSuggestionContent, FormatSuggestionContent, ReplaceSuggestionContent]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


