# coding: utf-8

"""
    Canva Connect API

    API for building integrations with Canva via a REST api

    The version of the OpenAPI document: latest
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from canva_alpha_ti.models.accepted_suggestion_event_type import AcceptedSuggestionEventType
from canva_alpha_ti.models.mention_suggestion_event_type import MentionSuggestionEventType
from canva_alpha_ti.models.new_suggestion_event_type import NewSuggestionEventType
from canva_alpha_ti.models.rejected_suggestion_event_type import RejectedSuggestionEventType
from canva_alpha_ti.models.reply_suggestion_event_type import ReplySuggestionEventType
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

SUGGESTIONEVENTTYPE_ONE_OF_SCHEMAS = ["AcceptedSuggestionEventType", "MentionSuggestionEventType", "NewSuggestionEventType", "RejectedSuggestionEventType", "ReplySuggestionEventType"]

class SuggestionEventType(BaseModel):
    """
    The type of suggestion event, along with additional type-specific properties.
    """
    # data type: NewSuggestionEventType
    oneof_schema_1_validator: Optional[NewSuggestionEventType] = None
    # data type: AcceptedSuggestionEventType
    oneof_schema_2_validator: Optional[AcceptedSuggestionEventType] = None
    # data type: RejectedSuggestionEventType
    oneof_schema_3_validator: Optional[RejectedSuggestionEventType] = None
    # data type: ReplySuggestionEventType
    oneof_schema_4_validator: Optional[ReplySuggestionEventType] = None
    # data type: MentionSuggestionEventType
    oneof_schema_5_validator: Optional[MentionSuggestionEventType] = None
    actual_instance: Optional[Union[AcceptedSuggestionEventType, MentionSuggestionEventType, NewSuggestionEventType, RejectedSuggestionEventType, ReplySuggestionEventType]] = None
    one_of_schemas: Set[str] = { "AcceptedSuggestionEventType", "MentionSuggestionEventType", "NewSuggestionEventType", "RejectedSuggestionEventType", "ReplySuggestionEventType" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = SuggestionEventType.model_construct()
        error_messages = []
        match = 0
        # validate data type: NewSuggestionEventType
        if not isinstance(v, NewSuggestionEventType):
            error_messages.append(f"Error! Input type `{type(v)}` is not `NewSuggestionEventType`")
        else:
            match += 1
        # validate data type: AcceptedSuggestionEventType
        if not isinstance(v, AcceptedSuggestionEventType):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AcceptedSuggestionEventType`")
        else:
            match += 1
        # validate data type: RejectedSuggestionEventType
        if not isinstance(v, RejectedSuggestionEventType):
            error_messages.append(f"Error! Input type `{type(v)}` is not `RejectedSuggestionEventType`")
        else:
            match += 1
        # validate data type: ReplySuggestionEventType
        if not isinstance(v, ReplySuggestionEventType):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ReplySuggestionEventType`")
        else:
            match += 1
        # validate data type: MentionSuggestionEventType
        if not isinstance(v, MentionSuggestionEventType):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MentionSuggestionEventType`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in SuggestionEventType with oneOf schemas: AcceptedSuggestionEventType, MentionSuggestionEventType, NewSuggestionEventType, RejectedSuggestionEventType, ReplySuggestionEventType. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in SuggestionEventType with oneOf schemas: AcceptedSuggestionEventType, MentionSuggestionEventType, NewSuggestionEventType, RejectedSuggestionEventType, ReplySuggestionEventType. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into NewSuggestionEventType
        try:
            instance.actual_instance = NewSuggestionEventType.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AcceptedSuggestionEventType
        try:
            instance.actual_instance = AcceptedSuggestionEventType.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into RejectedSuggestionEventType
        try:
            instance.actual_instance = RejectedSuggestionEventType.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ReplySuggestionEventType
        try:
            instance.actual_instance = ReplySuggestionEventType.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into MentionSuggestionEventType
        try:
            instance.actual_instance = MentionSuggestionEventType.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into SuggestionEventType with oneOf schemas: AcceptedSuggestionEventType, MentionSuggestionEventType, NewSuggestionEventType, RejectedSuggestionEventType, ReplySuggestionEventType. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into SuggestionEventType with oneOf schemas: AcceptedSuggestionEventType, MentionSuggestionEventType, NewSuggestionEventType, RejectedSuggestionEventType, ReplySuggestionEventType. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], AcceptedSuggestionEventType, MentionSuggestionEventType, NewSuggestionEventType, RejectedSuggestionEventType, ReplySuggestionEventType]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


